-- -------------------------------------------------------------------------- --
-- SpellTracker By Xulos ( EU ALLIANCE YSONDRE )      
-- -------------------------------------------------------------------------- --

UIPanelWindows["SpellTrackerFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };

SpellTracker = {};
SpellTracker.Version = GetAddOnMetadata("SpellTracker", "Version");
SpellTracker.BARS = {}; -- stock les abbres qui sont cr au dbut et sont dans le cache
SpellTracker.ScrollValue = 0; -- valeur de la scrolbar virtuelle
SpellTracker.CountBarToDisplay = 0;
SpellTracker.CountBarDisplayed = 0;
SpellTracker.CombatFlags = {
	[0x00004000]="TYPE_OBJECT",
	[0x00002000]="TYPE_GUARDIAN",
	[0x00001000]="TYPE_PET",
	[0x00000800]="TYPE_NPC",
	[0x00000400]="TYPE_PLAYER",
	[0x00000200]="CONTROL_NPC",
	[0x00000100]="CONTROL_PLAYER",
	[0x00000040]="REACTION_HOSTILE",
	[0x00000020]="REACTION_NEUTRAL",
	[0x00000010]="REACTION_FRIENDLY",
	[0x00000008]="AFFILIATION_OUTSIDER",
	[0x00000004]="AFFILIATION_RAID",
	[0x00000002]="AFFILIATION_PARTY",
	[0x00000001]="AFFILIATION_MINE",
};
-- Fonctions statiques GUI lies au XML
function SpellTrackerFrame_Init(self)
	SpellTrackerDB = SpellTrackerDB or {};
	
	SpellTrackerDB.SPELLS = SpellTrackerDB.SPELLS or {}; -- stock les infos a afficher
	
	SpellTrackerDB.Params = SpellTrackerDB.Params or {};
	SpellTrackerDB.Params.SpellBarHeight = SpellTrackerDB.Params.SpellBarHeight or 20;
	SpellTrackerDB.Params.FrameWidth = SpellTrackerDB.Params.FrameWidth or 600;
	SpellTrackerDB.Params.FrameHeight = SpellTrackerDB.Params.FrameHeight or 600;
	
	-- faudra trouver une formule pour calculer automatiquement la valeur selon le nombre de barres totales a afficher et le nombre de barres qu'on peut afficher
	-- en fait le mieux est jutse de tenir compte d'un ratio du nombre de barres qu'on peut afficher
	SpellTrackerDB.Params.SrollStep = 1; -- en nombres de barres
	
	-- indique la structure de donne / 0.40 / ( qui permet modifie les possibilti de filtrage ou d'affichage arborescent
	SpellTrackerDB.Params.DataStruct = SpellTrackerDB.Params.DataStruct or 
	{
		[0]="HitType", -- le meme sort peux faire du heal et du dgat
		[1]="SpellName", -- permet de pas tre embt avec un sort en 8... et son tick en 10... ( ce serait bien de faire le distinguo..; => a voir )
		[2]="SourceType+SourceName",
		[3]="TargetType+TargetName"
	};
	
	SpellTrackerDB.Params.Filters = SpellTrackerDB.Params.Filters or 
	{
		[1]="ByTotalAmountOfSpell",-- by default : totalt amount heal or damage of spell
		[2]="BySpellNature",-- heal or damage"
		[3]="BySpellName",-- nom du sort
		[4]="ByTargetNature",-- player or npc or vehicle or pet
		[5]="ByTargetName",--Name of target ( or GUID ? )
	};
	SpellTrackerDB.Params.FilterOrderToTake = SpellTrackerDB.Params.FilterOrderToTake or "1";-- filter list comma separated for filter use ex : "1,2,3,4"
	
	--Color => ce qui suit vien du fichier bli constant.lua
	--NORMAL_FONT_COLOR           = {r=1.0, g=0.82, b=0.0};
	--HIGHLIGHT_FONT_COLOR        = {r=1.0, g=1.0, b=1.0};
	--RED_FONT_COLOR              = {r=1.0, g=0.1, b=0.1};
	--DIM_RED_FONT_COLOR          = {r=0.8, g=0.1, b=0.1};
	--GREEN_FONT_COLOR            = {r=0.1, g=1.0, b=0.1};
	--GRAY_FONT_COLOR             = {r=0.5, g=0.5, b=0.5};
	--YELLOW_FONT_COLOR           = {r=1.0, g=1.0, b=0.0};
	--LIGHTYELLOW_FONT_COLOR      = {r=1.0, g=1.0, b=0.6};
	--ORANGE_FONT_COLOR           = {r=1.0, g=0.5, b=0.25};
	--PASSIVE_SPELL_FONT_COLOR    = {r=0.77, g=0.64, b=0.0};
	--BATTLENET_FONT_COLOR        = {r=0.510, g=0.773, b=1.0};
	SpellTrackerDB.Params.DefaultColor = SpellTrackerBar_GetColorCodeFromRGBStruct(NORMAL_FONT_COLOR);
	SpellTrackerDB.Params.FriendlyColor = SpellTrackerBar_GetColorCodeFromRGBStruct(GREEN_FONT_COLOR);
	SpellTrackerDB.Params.HostileColor = SpellTrackerBar_GetColorCodeFromRGBStruct(RED_FONT_COLOR);
	
	
	-- par default => SpellTrackerDB.Params.DefaultCountSpellsToTrack = 50; -- pilote le nombre de barres qui vont tre cres  l'avance
	-- un raid sur orgri ca fait 200 barres
	SpellTrackerDB.Params.DefaultCountSpellsToTrack = 200; -- pilote le nombre de barres qui vont tre cres  l'avance
	
	SpellTrackerDB.SPELLSTOTTRACK = SpellTrackerDB.SPELLSTOTTRACK or {}; -- stock les sort  traquer
	
	SpellTrackerDB.CurrentPlayerTracked = SpellTrackerDB.CurrentPlayerTracked or {};
	SpellTrackerDB.CurrentPlayerTracked.GUID = SpellTrackerDB.CurrentPlayerTracked.GUID or UnitGUID("player");
	SpellTrackerDB.CurrentPlayerTracked.Name = SpellTrackerDB.CurrentPlayerTracked.Name or UnitName("player");
	SpellTrackerDB.CurrentPlayerTracked.lvl = SpellTrackerDB.CurrentPlayerTracked.lvl or UnitLevel("player");
	SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked or true;
	SpellTrackerDB.MsgToolTip = SpellTrackerDB.MsgToolTip or "Track Source";
	
	SpellTrackerButton_UpdateTitle();
	
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame:SetWidth(SpellTrackerDB.Params.FrameWidth);
		SpellTrackerFrame:SetHeight(SpellTrackerDB.Params.FrameHeight);
	end
end
function SpellTrackerMinimapButton_OnClick(self)
    if (SpellTrackerFrame) then
        if(SpellTrackerFrame:IsVisible() ) then
            SpellTrackerFrame:Hide();
		else
            SpellTrackerFrame:Show();
			SpellTracker:UpdateFrame();
		end
    end
end
function hideSpellTrackerFrameButton_OnClick(self) -- Bouton pour fermer la mainFrame
	if (SpellTrackerFrame) then
        SpellTrackerFrame:Hide();
    end
end
function resetSpellTrackerButton_OnClick(self) -- Bouton pour reset les sorts traqus
	SpellTrackerDB.SPELLS = {};
	SpellTrackerButton_UpdateTitle();
	SpellTracker:UpdateFrame();
end
function otherTargetSpellTrackerButton_OnClick(self, ...)
	local btnUsed = GetMouseButtonClicked();
	if ( btnUsed == "LeftButton" and UnitGUID("target") ) then
		SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("target");
		SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("target");
		SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
	elseif ( btnUsed == "RightButton" ) then
		SpellTrackerDB.CurrentPlayerTracked.GUID = nil;
		SpellTrackerDB.CurrentPlayerTracked.Name = nil;
		SpellTrackerDB.CurrentPlayerTracked.lvl = nil;
	else
		SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("player");
		SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("player");
		SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
	end
	resetSpellTrackerButton_OnClick(self);
end
function AttackORAttackedSpellTrackerButton_OnClick(self)
	SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = not SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked;
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		SpellTrackerDB.MsgToolTip = "Track Source";
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then -- peut valoir nil on sait jamais
		SpellTrackerDB.MsgToolTip = "Track Dest";
	end
	resetSpellTrackerButton_OnClick(self);
end
function FilterSpellTrackerButton_OnClick(self)
end
function SpellTrackerButton_UpdateTitle()
	local vers = SpellTracker.Version;
	local pName = SpellTrackerDB.CurrentPlayerTracked.Name;
	local srcORdst = "";
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		srcORdst = "SRC";
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		srcORdst = "DST";
	end
	if ( pName == nil ) then -- zone tracking
		SpellTrackerFrameMainMenuTitleTitleText:SetText("SpellTracker r"..vers.." -- Zone Tracking Mode".." by "..srcORdst);
	else
		SpellTrackerFrameMainMenuTitleTitleText:SetText("SpellTracker r"..vers.." -- Player Tracked : "..pName.." by "..srcORdst);
	end
end
function SpellTrackerButton_ShowTooltip(self, LMBtextToShow, LMDtextToShow)
	if ( LMBtextToShow and LMDtextToShow ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText("LMB :"..LMBtextToShow);
		GameTooltip:AddLine("LMD :"..LMDtextToShow);
		GameTooltip:Show();
	elseif ( LMBtextToShow and not LMDtextToShow ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(LMBtextToShow);
		GameTooltip:Show();
	elseif ( SpellTrackerDB.MsgToolTip ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(SpellTrackerDB.MsgToolTip);
		GameTooltip:Show();
	end
end
function SpellTrackerButton_HideTooltip(self)
	 GameTooltip:Hide();
end
function SpellTrackerBar_OnEnter(self) -- affiche des infos sup sur les sort traqus
	if ( self.VAR.Used ) then 
		GameTooltip:SetOwner(self);
		if ( self.VAR.SpellIndexer ) then
			local SpellStruct = SpellTrackerDB.SPELLS[self.VAR.SpellIndexer];
			if ( SpellStruct ) then
			
				local HitTypeColor  = SpellTrackerDB.Params.HostileColor;
				if ( SpellStruct.SpellHitType == "HEAL" ) then HitTypeColor = SpellTrackerDB.Params.FriendlyColor; end
					
				GameTooltip:SetText(HitTypeColor..SpellStruct.SpellName);
					
				local nBarRatio = tostring(self.VAR.SpellListToSort_Position).."/"..tostring(SpellTracker.CountBarToDisplay);
				GameTooltip:AddLine("Bar "..nBarRatio);
				
				-- colorise en vert ou en rouge selon que la source soie hostile ou friendly
				local SrcColor = SpellTrackerDB.Params.FriendlyColor;
				local DstColor = SpellTrackerDB.Params.FriendlyColor;
				if ( SpellStruct.ReactionSrc == "REACTION_HOSTILE" ) then SrcColor = SpellTrackerDB.Params.HostileColor; end
				if ( SpellStruct.ReactionDst == "REACTION_HOSTILE" ) then DstColor = SpellTrackerDB.Params.HostileColor; end
					
				GameTooltip:AddDoubleLine("Source Type/Name :",SrcColor..SpellStruct.SourceType.." / "..SpellStruct.SourceName);
				GameTooltip:AddDoubleLine("Target Type/Name :",DstColor..SpellStruct.TargetType.." / "..SpellStruct.TargetName);
				
				local StatBarColor = SpellTracker.StatusBarColors;
				
				-- Recup des donnes / 0.40
				local LocalStruct = {};
				LocalStruct.SpellHitAmount, LocalStruct.SpellHitAndCritAmount, 
					LocalStruct.SpellCritAmount, LocalStruct.SpellCritAndOverAmount, LocalStruct.SpellOverAmount, 
					LocalStruct.SpellOverAndAbsorbAmount, LocalStruct.SpellCritAndAbsorbAmount, LocalStruct.SpellAbsorbAmount
					= string.match(SpellStruct.AmountLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");

	
				-- self.SpellHitType vaut "Heal" ou "Damage" / modif 0.40
				GameTooltip:AddLine("----- "..SpellStruct.SpellHitType.." : -----");
				GameTooltip:AddDoubleLine(StatBarColor.SpellHitAmount..SpellStruct.SpellHitType.." Hit Amount :",StatBarColor.SpellHitAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellHitAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAmount..SpellStruct.SpellHitType.." Crit Amount :",StatBarColor.SpellCritAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndOverAmount..SpellStruct.SpellHitType.." Over & Crit Amount :",StatBarColor.SpellCritAndOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndOverAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAmount..SpellStruct.SpellHitType.." Over Amount :",StatBarColor.SpellOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAndAbsorbAmount..SpellStruct.SpellHitType.." Over & Absorb Amount :",StatBarColor.SpellOverAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAndAbsorbAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndAbsorbAmount..SpellStruct.SpellHitType.." Crit & Absorb Amount :",StatBarColor.SpellCritAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndAbsorbAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount..SpellStruct.SpellHitType.." Absorb Amount :",StatBarColor.SpellAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellAbsorbAmount));
				GameTooltip:AddLine("----- "..SpellStruct.SpellHitType.." Total Produced : -----");
				GameTooltip:AddDoubleLine("Amount :",SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellAmountTotal));
				
				-- Recup des Ticks / 0.40
				LocalStruct.CountSpellHit, LocalStruct.CountSpellMissed, LocalStruct.CountSpellImmune, 
					LocalStruct.CountSpellAbsorb, LocalStruct.CountSpellOver, LocalStruct.CountSpellCrit, LocalStruct.CountSpellCritAndOver, 
					LocalStruct.CountSpellCritAndAbsorb, LocalStruct.CountSpellOverAndAbsorb
					= string.match(SpellStruct.TicksLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
	
				GameTooltip:AddLine("----- Count "..SpellStruct.SpellHitType.." Ticks : -----");
				GameTooltip:AddDoubleLine("Count Ticks ", SpellStruct.CountTicks);
				GameTooltip:AddDoubleLine(StatBarColor.SpellHitAmount.." Count Hit ", StatBarColor.SpellHitAmount..(LocalStruct.CountSpellHit));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAmount.." Count Over ", StatBarColor.SpellOverAmount..(LocalStruct.CountSpellOver));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAmount.." Count Crits ", StatBarColor.SpellCritAmount..(LocalStruct.CountSpellCrit));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndOverAmount.." Count Crit & Over ", StatBarColor.SpellCritAndOverAmount..(LocalStruct.CountSpellCritAndOver));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndAbsorbAmount.." Count Crit & Absorb ", StatBarColor.SpellCritAndAbsorbAmount..(LocalStruct.CountSpellCritAndAbsorb));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAndAbsorbAmount.." Count Over & Absorb ", StatBarColor.SpellOverAndAbsorbAmount..(LocalStruct.CountSpellOverAndAbsorb));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Missed ", StatBarColor.SpellAbsorbAmount..(LocalStruct.CountSpellMissed));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Immune ", StatBarColor.SpellAbsorbAmount..(LocalStruct.CountSpellImmune));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Absorb ", StatBarColor.SpellAbsorbAmount..(LocalStruct.CountSpellAbsorb));
				
				GameTooltip:Show();
			end
		end
	end
end
function SpellTrackerBar_FormatAmountValueToString(val)
	if (string.len(tostring(val)) > 4 ) then
		return string.format("%.0f", val/1000).."K";
	elseif (string.len(tostring(val)) > 7 ) then
		return string.format("%.0f", val/1000000).."m";
	elseif (string.len(tostring(val)) > 10 ) then
		return string.format("%.0f", val/1000000).."M";
	else
		return string.format("%.0f", val);
	end
end
function SpellTrackerBar_GetColorCodeFromStatusBarColor(StatusBar)
	local codeWow = nil;
	if ( StatusBar ) then
		local r,g,b,a = StatusBar:GetStatusBarColor();
		if ( r and g and b ) then
			codeWow = SpellTrackerBar_GetColorCodeFromRGB(r, g, b);
		end
	end
	return codeWow; 
end
function SpellTrackerBar_GetColorCodeFromRGB(red, green, blue) -- de 0  1 en float
	local codeWow = nil;
	if ( red and green and blue ) then
		local redColor = string.format("%0.2X", math.ceil(string.format("%.2f", red)*255));
		local greenColor = string.format("%0.2X", math.ceil(string.format("%.2f", green)*255));
		local blueColor = string.format("%0.2X", math.ceil(string.format("%.2f", blue)*255));
		codeWow = "|cFF"..tostring(redColor)..tostring(greenColor)..tostring(blueColor);
	end
	return codeWow; 
end
function SpellTrackerBar_GetColorCodeFromRGBStruct(rgbStruct) -- de 0  1 en float
	local codeWow = SpellTrackerBar_GetColorCodeFromRGB(rgbStruct.r, rgbStruct.g, rgbStruct.b);
	return codeWow; 
end
function SpellTrackerBar_OnLeave(self)
    GameTooltip:Hide();
end
function SpellTrackerMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("SpellTracker "..SpellTracker.Version);
end
function SpellTrackerMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function SpellTrackerResizeFrame_OnEnter(self) -- widget de redimentionnement -- survol IN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(false);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(1);
	end
end
function SpellTrackerResizeFrame_OnLeave(self) -- widget de redimentionnement -- survol OUT
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(true);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(0);
	end
end
function SpellTrackerResizeFrame_OnMouseDown(self) -- widget de redimentionnement -- CLICK DOWN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame.isMovingOrSizing = false;
		local minHeight = SpellTrackerFrameMainMenuTitle:GetHeight() + SpellTrackerDB.Params.SpellBarHeight + 2;
		SpellTrackerFrame:SetMinResize(80, minHeight);
		SpellTrackerFrame:SetMaxResize(800, 0);
		SpellTrackerFrame:StartSizing();
	end
end
function SpellTrackerResizeFrame_OnMouseUp(self) -- widget de redimentionnement -- CLICK UP
	if ( UnitAffectingCombat("player") == nil ) then
		-- on reajuste la valuer y a un mulitple de Hbarre + offsety
		local barHeight = SpellTrackerDB.Params.SpellBarHeight + 2; -- 2 == offset
		local minHeight = SpellTrackerFrameMainMenuTitle:GetHeight() + barHeight;
		SpellTracker.CountBarDisplayed = math.floor(SpellTrackerFrameContainer:GetHeight() / barHeight);
		--print("SpellTracker.CountBarDisplayed=",SpellTracker.CountBarDisplayed);
		local newSpellTrackerFrameContainerHeight = SpellTracker.CountBarDisplayed*barHeight;
		local newSpellTrackerFrameHeight = (SpellTrackerFrame:GetHeight() - SpellTrackerFrameContainer:GetHeight()) + newSpellTrackerFrameContainerHeight;
		if ( newSpellTrackerFrameHeight < minHeight ) then newSpellTrackerFrameHeight = minHeight; end
		SpellTrackerFrame:SetHeight(newSpellTrackerFrameHeight);
		SpellTrackerDB.Params.FrameHeight = newSpellTrackerFrameHeight;
		
		SpellTrackerFrame:StopMovingOrSizing();
		SpellTrackerFrame:ClearAllPoints();
		SpellTrackerFrame.isMovingOrSizing = nil;
		SpellTrackerDB.Params.FrameWidth = SpellTrackerFrame:GetWidth();
		
		SpellTracker:InitFrame(); -- on a redimentionn donc on reinit le layout	
		SpellTracker:UpdateFrame(); -- on update la frame
	end
end
function SpellTrackerFrameContainer_OnLoad(self) -- chargement du container du grid
	self:RegisterForDrag("LeftButton");
	--self:SetScrollChild(SpellTrackerFrameContainerContainer);
end
function SpellTrackerFrameContainerVirtualScrollBar_OnMouseWheel (self, delta, stepSize) -- se produit quand la molette de la sourie roule
	-- SpellTracker.ScrollValue => correspond au numro de la barre affich en haut
	-- SpellTracker.CountBarToDisplay => correspond au nombre de barres  afficher 
	-- SpellTracker.CountBarDisplayed => correspond au nombres de bars qui puevent etre affcihs en meme temps.
	if ( delta ) then
		local minVal, maxVal = 0, SpellTracker.CountBarToDisplay-SpellTracker.CountBarDisplayed;
		if ( maxVal < 0 ) then maxVal = 0; end
		--print("SpellTracker.CountBarDisplayed=",SpellTracker.CountBarDisplayed);
		if ( delta == 1 ) then
			SpellTracker.ScrollValue = max(minVal, SpellTracker.ScrollValue - SpellTrackerDB.Params.SrollStep);
		elseif ( delta == -1 ) then
			SpellTracker.ScrollValue = min(maxVal, SpellTracker.ScrollValue + SpellTrackerDB.Params.SrollStep);
		end
		
		SpellTracker:UpdateFrame();
	end
end	
function SpellTrackerFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_REGEN_DISABLED"); -- Get Aggro
    self:RegisterEvent("PLAYER_REGEN_ENABLED");	-- Leave Aggro
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED"); -- recuper les event de combat 
end
function SpellTrackerFrame_OnEvent(self, event, ...)
	if ( event == "VARIABLES_LOADED" ) then
		SpellTrackerFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == nil ) then
			SpellTracker:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTracker.Version.." LOADED");
			SpellTracker:UpdateFrame();
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTracker.Version.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(self, ...);
	end
end
-- kernel --
function SpellTracker:CreateBar(frmName)
    local GuiBar = CreateFrame("Button", frmName, SpellTrackerFrame, "SpellTrackerBarTemplate");
        
	GuiBar:RegisterForClicks("AnyUp");
	
	GuiBar.GUI = {};
	GuiBar.GUI.SpellIcon = _G[frmName.."StatusBarSpellHitSpellIcon"];
	GuiBar.GUI.SpellNameLabel = _G[frmName.."StatusBarSpellHitSpellNameLabel"];
	GuiBar.GUI.SpellSpellAmountLabel = _G[frmName.."StatusBarSpellHitSpellAmountLabel"];
	--GuiBar.GUI.SpellOverHitLabel = _G[frmName.."StatusBarSpellHitSpellOverHitLabel"];
	--GuiBar.GUI.SpellCritAmountLabel = _G[frmName.."StatusBarSpellHitSpellCritAmountLabel"];
	--GuiBar.GUI.SpellAbsorbAmountLabel = _G[frmName.."StatusBarSpellHitSpellAbsorbAmountLabel"];
	--GuiBar.GUI.SpellOverHitAndAbsorbAmount = _G[frmName.."StatusBarSpellHitSpellOverHitAndAbsorbAmountLabel"];
	--GuiBar.GUI.SpellCritAndAbsorbAmount = _G[frmName.."StatusBarSpellHitSpellCritAndAbsorbAmountLabel"];
	
	GuiBar.GUI.StatusBarSpellHit = _G[frmName.."StatusBarSpellHit"];
	GuiBar.GUI.StatusBarSpellHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAmountAndHit = _G[frmName.."StatusBarSpellCritAmountAndHit"];
	GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAmount = _G[frmName.."StatusBarSpellCritAmount"];
	GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmount:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHitAndCrit = _G[frmName.."StatusBarSpellOverHitAndCrit"];
	GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHit = _G[frmName.."StatusBarSpellOverHit"];
	GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb = _G[frmName.."StatusBarSpellOverHitAndAbsorb"];
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAndAbsorb = _G[frmName.."StatusBarSpellCritAndAbsorb"];
	GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellAbsorbAmount = _G[frmName.."StatusBarSpellAbsorbAmount"];
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetMinMaxValues(0, 100);
	
	if ( SpellTracker.StatusBarColors == nil ) then -- pour le tooltip de la barre
		SpellTracker.StatusBarColors = {};
		SpellTracker.StatusBarColors.SpellHitAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellHit)
		SpellTracker.StatusBarColors.SpellCritAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellCritAmount)
		SpellTracker.StatusBarColors.SpellCritAndOverAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHitAndCrit)
		SpellTracker.StatusBarColors.SpellOverAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHit)
		SpellTracker.StatusBarColors.SpellOverAndAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHitAndAbsorb)
		SpellTracker.StatusBarColors.SpellCritAndAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellCritAndAbsorb)
		SpellTracker.StatusBarColors.SpellAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellAbsorbAmount)
	end
    GuiBar.VAR = {};
	GuiBar.VAR.SpellIndexer = nil;
	GuiBar.VAR.SpellTracked = false; -- si le spell est demand a traquer
	GuiBar.VAR.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
	
	GuiBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
    GuiBar:SetBackdropBorderColor(0, 0, 0, 0);
	
	return GuiBar;
end
function SpellTracker:ResetBar(GuiBar)
	if ( GuiBar ) then
		GuiBar.GUI.SpellIcon:SetTexture(1,1,1,0); -- on la rend transparante => texture:SetTexture(r, g, b[, a]) avec a = 0
		GuiBar.GUI.SpellNameLabel:SetText("");
		GuiBar.GUI.SpellSpellAmountLabel:SetText("");
		
		GuiBar.GUI.StatusBarSpellHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(0);
		GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
		
		GuiBar.VAR.Used = false;
	end
end
function SpellTracker:InitFrame()
	local mFrameContainer = SpellTrackerFrameContainer;
	SpellTracker.CountBarDisplayed = math.floor(mFrameContainer:GetHeight() / (SpellTrackerDB.Params.SpellBarHeight + 2));
	--print("SpellTracker.CountBarDisplayed=",SpellTracker.CountBarDisplayed);
	--SpellTrackerDB.Params.SrollStep = math.floor(SpellTracker.CountBarDisplayed/3); -- le nombre de barres qu'on peut afficher sur 3 est un bon ration mais que ce apsste
	local idx = 1;
	if ( #SpellTracker.BARS < SpellTracker.CountBarDisplayed ) then
		local countBarToCreate = SpellTracker.CountBarDisplayed; --SpellTrackerDB.Params.DefaultCountSpellsToTrack; tait dfini par parametrage avant et coutait pas mal de mmoire du coup
		for k=0,countBarToCreate do 
			local frmName = "SpellTrackerBar"..tostring(idx);
			if ( _G[frmName] == nil ) then -- si la barre a pas encore t cr on la cr / permet de s'assurer qu'on aura tujours un nombre de barres suffisant et en corlation avec la fenetre
				local Bar = SpellTracker:CreateBar(frmName);
				--Bar:Hide();
				SpellTracker.BARS[idx] = Bar;
			end
			idx = idx + 1;
		end
	else
		-- on montre celles qui doivent etre utilise et on cache les autres
		for i=0, #SpellTracker.BARS do
			local frmName = "SpellTrackerBar"..tostring(i);
			if ( _G[frmName] ) then
				if ( i <= SpellTracker.CountBarDisplayed ) then
					_G[frmName]:Show(); 
				else
					_G[frmName]:Hide(); 
				end
			end
		end
	end
	
	local offsetY = -2;
    
	local ncolMax, nrowMax, itW, itH = 0, 0, 0, 0;
	local nrowMax = math.ceil(#SpellTracker.BARS);
	
	mFrameContainer:SetWidth(SpellTrackerFrame:GetWidth());
	
	local itW = mFrameContainer:GetWidth();
    local itH = SpellTrackerDB.Params.SpellBarHeight;
	
	local heightMax = nrowMax * itH + offsetY * nrowMax * -1;
	
	mFrameContainer:SetHeight(heightMax);
	
    local lastGuiBar = nil;
	for idx, guiBar in pairs(SpellTracker.BARS) do
		if ( guiBar ) then
			guiBar:SetParent(mFrameContainer);
			if ( lastGuiBar == nil ) then
				guiBar:SetPoint("TOPLEFT", mFrameContainer, "TOPLEFT", 0, 0);
			else
				guiBar:SetPoint("TOPLEFT", lastGuiBar, "BOTTOMLEFT", 0, offsetY);
			end
			guiBar:SetWidth(itW);
			guiBar:SetHeight(itH);
			lastGuiBar = guiBar;
		end
    end
end
function SpellTracker:UpdateFrame()
	local SpellListToSort = {};
	for spellIndexer, spellStruct in pairs(SpellTrackerDB.SPELLS) do
        if ( spellIndexer and spellStruct ) then 
			tinsert(SpellListToSort, spellStruct);
        end
    end
	
	sort(SpellListToSort, 
		function(x,y)
			if ( x and y ) then
				if  ( x.SpellTracked and y.SpellTracked ) then
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				elseif ( x.SpellTracked ) then 
					return true; 
				elseif ( y.SpellTracked ) then 
					return false;
				else -- not ( x.SpellTracked and y.SpellTracked ) 
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				end	
			end
		end);
	
	for i, bar in pairs(SpellTracker.BARS) do
		if ( bar ) then
			if ( bar.VAR.Used ) then -- la barre est utlise;
				SpellTracker:ResetBar(bar); -- on la reset, car la cahcher va porvoquer une erreur en combat
			end
		end
	end
	
	local StatBarColor = SpellTracker.StatusBarColors;
				
	local SpellListToSort_Position = 1;
	local idx = 1; 
	
	for spellIndexer, spellStruct in pairs(SpellListToSort) do
		if ( spellIndexer ) then
			if ( SpellListToSort_Position > SpellTracker.ScrollValue and SpellListToSort_Position <= (SpellTracker.ScrollValue + SpellTracker.CountBarDisplayed) ) then -- correspond a la position de la barre dsire comme cela on n'naffiche que les barres qui sont affichable -- gain mmoire donc
				local GuiBar = SpellTracker.BARS[idx];
				if ( GuiBar ) then
					GuiBar.GUI.SpellIcon:SetTexture(spellStruct.SpellIconTex); -- Spell Icon
					GuiBar.VAR.SpellIndexer = spellStruct.SpellIndexer;
					
					GuiBar.VAR.SpellListToSort_Position = SpellListToSort_Position;
					
					-- plus besoin d'afficher un D ou un H => a la palce j'utilise la couleur rouge pour d et vert pour h
					local HitTypeColor  = "";
					if ( spellStruct.SpellHitType == "HEAL" ) then HitTypeColor = SpellTrackerDB.Params.FriendlyColor; -- heal en vert
					else HitTypeColor = SpellTrackerDB.Params.HostileColor; end -- degat en rouge
					
					local TargetType  = "";
					if ( spellStruct.TargetType == "player" ) then TargetType = "P";
					elseif ( spellStruct.TargetType == "mob" ) then TargetType = "M";
					elseif ( spellStruct.TargetType == "vehicle" ) then TargetType = "V";
					elseif ( spellStruct.TargetType == "pet" ) then TargetType = "p";
					end
					
					local SourceType  = "";
					if ( spellStruct.SourceType == "player" ) then SourceType = "P";
					elseif ( spellStruct.SourceType == "mob" ) then SourceType = "M";
					elseif ( spellStruct.SourceType == "vehicle" ) then SourceType = "V";
					elseif ( spellStruct.SourceType == "pet" ) then SourceType = "p";
					end
					
					local SpellDirection = "";
					if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then SpellDirection = " => ";
					else SpellDirection = " <= ";
					end
					
					-- colorise en vert ou en rouge selon que la source soie hostile ou friendly
					local SourceName = "";
					if ( spellStruct.ReactionSrc == "REACTION_HOSTILE" ) then -- Hostile
						SourceName = SpellTrackerDB.Params.HostileColor..spellStruct.SourceName;
						SourceType = SpellTrackerDB.Params.HostileColor..SourceType;
					else -- Friendly
						SourceName = SpellTrackerDB.Params.FriendlyColor..spellStruct.SourceName;
						SourceType = SpellTrackerDB.Params.FriendlyColor..SourceType;
					end
					
					-- colorise en vert ou en rouge selon que la cible soie hostile ou friendly
					local TargetName = "";
					if ( spellStruct.ReactionDst == "REACTION_HOSTILE" ) then -- Hostile
						TargetName = SpellTrackerDB.Params.HostileColor..spellStruct.TargetName;
						TargetType = SpellTrackerDB.Params.HostileColor..TargetType;
					else -- Friendly
						TargetName = SpellTrackerDB.Params.FriendlyColor..spellStruct.TargetName;
						TargetType = SpellTrackerDB.Params.FriendlyColor..TargetType;
					end
					
					GuiBar.GUI.SpellNameLabel:SetText(	tostring(SpellListToSort_Position)
														.." "..tostring(HitTypeColor)
														.." "..tostring(spellStruct.SpellName)
														..SpellTrackerDB.Params.DefaultColor.." x"..tostring(spellStruct.CountTicks) -- default color pour les ticks
														.." "..tostring(SourceType)
														.." "..tostring(SourceName)
														..SpellTrackerDB.Params.DefaultColor..SpellDirection..tostring(TargetType)
														.." "..tostring(TargetName));
			
					-- On recupe les donnes Amount / 0.40
					local LocalStruct = {};
					LocalStruct.SpellHitAmount, LocalStruct.SpellHitAndCritAmount, 
						LocalStruct.SpellCritAmount, LocalStruct.SpellCritAndOverAmount, LocalStruct.SpellOverAmount, 
						LocalStruct.SpellOverAndAbsorbAmount, LocalStruct.SpellCritAndAbsorbAmount, LocalStruct.SpellAbsorbAmount
						= string.match(spellStruct.AmountLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
					LocalStruct.SpellHitAmount = tonumber(LocalStruct.SpellHitAmount);
					LocalStruct.SpellHitAndCritAmoun4t = tonumber(LocalStruct.SpellHitAndCritAmount);
					LocalStruct.SpellCritAmount = tonumber(LocalStruct.SpellCritAmount);
					LocalStruct.SpellCritAndOverAmount = tonumber(LocalStruct.SpellCritAndOverAmount);
					LocalStruct.SpellOverAmount = tonumber(LocalStruct.SpellOverAmount);
					LocalStruct.SpellOverAndAbsorbAmount = tonumber(LocalStruct.SpellOverAndAbsorbAmount);
					LocalStruct.SpellCritAndAbsorbAmount = tonumber(LocalStruct.SpellCritAndAbsorbAmount);
					LocalStruct.SpellAbsorbAmount = tonumber(LocalStruct.SpellAbsorbAmount);
					
					local AmountString = 
					StatBarColor.SpellHitAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellHitAmount).."/"..
					StatBarColor.SpellCritAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAmount).."/"..
					StatBarColor.SpellCritAndOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndOverAmount).."/"..
					StatBarColor.SpellOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAmount).."/"..
					StatBarColor.SpellOverAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAndAbsorbAmount).."/"..
					StatBarColor.SpellCritAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndAbsorbAmount).."/"..
					StatBarColor.SpellAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellAbsorbAmount);
					
					GuiBar.GUI.SpellSpellAmountLabel:SetText(AmountString);
					
					if ( spellStruct.SpellAmountTotal > 0 ) then
						local HitAmount = LocalStruct.SpellHitAmount*100/spellStruct.SpellAmountTotal;
						--local HitAndCritAmount = LocalStruct.SpellHitAndCritAmount*100/spellStruct.SpellAmountTotal;
						local CritAmount = LocalStruct.SpellCritAmount*100/spellStruct.SpellAmountTotal;
						local OverHitAndCritAmount = LocalStruct.SpellCritAndOverAmount*100/spellStruct.SpellAmountTotal;
						local OverHitAmount = LocalStruct.SpellOverAmount*100/spellStruct.SpellAmountTotal;
						local OverHitAmountAndAbsorb = LocalStruct.SpellOverAndAbsorbAmount*100/spellStruct.SpellAmountTotal;
						local CritAmountAndAbsorb = LocalStruct.SpellCritAndAbsorbAmount*100/spellStruct.SpellAmountTotal;
						
						GuiBar.GUI.StatusBarSpellHit:SetValue(HitAmount);
						GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
						GuiBar.GUI.StatusBarSpellCritAmount:SetValue(CritAmount+HitAmount);
						GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(OverHitAndCritAmount+CritAmount+HitAmount);
						GuiBar.GUI.StatusBarSpellOverHit:SetValue(OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
						GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(OverHitAmountAndAbsorb+OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
						GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(CritAmountAndAbsorb+OverHitAmountAndAbsorb+OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
						GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(100);
					end
					
					GuiBar.VAR.Used = true;
				end
				idx = idx + 1;
			end
			SpellListToSort_Position = SpellListToSort_Position + 1;
		end
	end
	SpellTracker.CountBarToDisplay = #SpellListToSort;
	
end
function SpellTracker:WhatIsThisFlag(flag)
	if ( flag == nil )  then return; end
	if ( flag == 0 )  then return; end
    -- on sort quatre infos utile : TYPE CONTROL REACTION AFFILIATION
	local flagType, flagControl, flagReaction, flagAffiliation;

	if ( bit.band(flag, 0x00004000) > 0 ) then flagType = SpellTracker.CombatFlags[0x00004000]; end -- TYPE_OBJECT
	if ( bit.band(flag, 0x00002000) > 0 ) then flagType = SpellTracker.CombatFlags[0x00002000]; end -- TYPE_GUARDIAN
	if ( bit.band(flag, 0x00001000) > 0 ) then flagType = SpellTracker.CombatFlags[0x00001000]; end -- TYPE_PET
	if ( bit.band(flag, 0x00000800) > 0 ) then flagType = SpellTracker.CombatFlags[0x00000800]; end -- TYPE_NPC
	if ( bit.band(flag, 0x00000400) > 0 ) then flagType = SpellTracker.CombatFlags[0x00000400]; end -- TYPE_PLAYER
	
	if ( bit.band(flag, 0x00000200) > 0 ) then flagControl = SpellTracker.CombatFlags[0x00000200]; end -- CONTROL_NPC
	if ( bit.band(flag, 0x00000100) > 0 ) then flagControl = SpellTracker.CombatFlags[0x00000100]; end -- CONTROL_PLAYER
	
	if ( bit.band(flag, 0x00000040) > 0 ) then flagReaction = SpellTracker.CombatFlags[0x00000040]; end -- REACTION_HOSTILE
	if ( bit.band(flag, 0x00000020) > 0 ) then flagReaction = SpellTracker.CombatFlags[0x00000020]; end -- REACTION_NEUTRAL
	if ( bit.band(flag, 0x00000010) > 0 ) then flagReaction = SpellTracker.CombatFlags[0x00000010]; end -- REACTION_FRIENDLY
	
    if ( bit.band(flag, 0x00000008) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000008]; end -- AFFILIATION_OUTSIDER
	if ( bit.band(flag, 0x00000004) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000004]; end -- AFFILIATION_RAID
	if ( bit.band(flag, 0x00000002) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000002]; end -- AFFILIATION_PARTY
	if ( bit.band(flag, 0x00000001) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000001]; end -- AFFILIATION_MINE
    
    return flagType, flagControl, flagReaction, flagAffiliation;
end
function SpellTracker:WhatIsThisGuid(GUIDNumber)
	if ( GUIDNumber ~= nil and GUIDNumber ~= "" ) then
		local maskedB = tonumber(GUIDNumber:sub(5,5), 16) % 8; 
		local knownTypes = {[0]="player", [1]="object", [3]="mob", [4]="pet", [5]="vehicle"};
		local result = knownTypes[maskedB] or "Unknow";
		return result; 
    end
    return "Unknow";
end
function SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(_,DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local TargetType, GUID = nil, TargetName, SourceName, SourceType;
		
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		GUID = GUIDSRC;
		SourceType = SpellTracker:WhatIsThisGuid(GUIDSRC);
		SourceName = tostring(SRC);
		TargetType = SpellTracker:WhatIsThisGuid(GUIDDST);
		TargetName = tostring(DST);
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		GUID = GUIDDST;
		SourceType = SpellTracker:WhatIsThisGuid(GUIDDST);
		SourceName = tostring(DST);
		TargetType = SpellTracker:WhatIsThisGuid(GUIDSRC);
		TargetName = tostring(SRC);
	end
        
	if ( SpellTrackerDB.CurrentPlayerTracked.GUID ) then
		if ( GUID == SpellTrackerDB.CurrentPlayerTracked.GUID ) then
			local struct = SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...);
			if ( struct ) then
				SpellTracker:UpdateSpell(SourceType, SourceName, TargetType, TargetName, struct);
			end
		end
	else -- zone tracking enabled
		local struct = SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...);
		if ( struct ) then
			SpellTracker:UpdateSpell(SourceType, SourceName, TargetType, TargetName, struct);
		end
	end
end
function SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local Struct = nil;
	if ( EVENTTYPE == "SPELL_DAMAGE" ) then -- domage de sort
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL, Struct.RESISTED,	Struct.BLOCKED,	
		Struct.ABSORBED, Struct.CRITICAL, Struct.GLANCING, Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_DAMAGE" ) then -- dommage de sort en tick genre dot fievre de givre
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL, Struct.RESISTED, Struct.BLOCKED,	
		Struct.ABSORBED, Struct.CRITICAL, Struct.GLANCING, Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE SPELL TICK";
	elseif ( EVENTTYPE == "SWING_DAMAGE" ) then -- coup blanc
		Struct = {};
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL, Struct.RESISTED,	Struct.BLOCKED,	
		Struct.ABSORBED, Struct.CRITICAL, Struct.GLANCING, Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.SPELLNAME = "COUP BLANC";
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE COUP BLANC";
	elseif ( EVENTTYPE == "SPELL_HEAL" ) then -- sort de soins
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERHEALING,
		Struct.ABSORBED, Struct.CRITICAL = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "HEAL";
		Struct.TYPE = "HEAL SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_HEAL" ) then -- tick de sort de soins
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERHEALING,
		Struct.ABSORBED, Struct.CRITICAL = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "HEAL";
		Struct.TYPE = "HEAL SPELL TICK";
	elseif ( EVENTTYPE == "SPELL_MISSED" ) then -- Sort Manqu ou partiellement manqu
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_MISSED" ) then -- Tick de Sort Manqu ou partiellement manqu
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED SPELL TICK";
	elseif ( EVENTTYPE == "SWING_MISSED" ) then -- coup blanc maqnu
		Struct = {};
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.SPELLNAME = "COUP BLANC";
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED COUP BLANC";
	end
	if ( Struct ) then
		Struct.SRCFLAG1 = SRCFLAG1;
		Struct.DSTFLAG1 = DSTFLAG1;
	end
	return Struct;
end
function SpellTracker:GetAllSpellTexture(spellID) -- 0.40 / pour remplacer
	if ( spellID ) then
		name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spellID);
		return icon;
	end
	return nil;
end
function SpellTracker:UpdateSpell(SourceType, SourceName, TargetType, TargetName, CombatLogStruct) -- TargetType = player or MOB / 
	-- voir http://www.wowwiki.com/API_COMBAT_LOG_EVENT
	local SpellIndexer, SpellStruct;
			
	local flagTypeSrc, flagControlSrc, flagReactionSrc, flagAffiliationSrc = SpellTracker:WhatIsThisFlag(CombatLogStruct.SRCFLAG1);
	local flagTypeDst, flagControlDst, flagReactionDst, flagAffiliationDst = SpellTracker:WhatIsThisFlag(CombatLogStruct.DSTFLAG1);
	
	-- Init or not
	
	-- l'indexer est ce qui fait la disctinction des filtres
	SpellIndexer = tostring(CombatLogStruct.HITTYPE).."-"..tostring(CombatLogStruct.SPELLNAME).."-"..tostring(SourceType).."-"..tostring(SourceName).."-"..tostring(TargetType).."-"..tostring(TargetName); -- parce que sur certains perso le meme sort peux faire du heal et du dgat
	--SpellIndexer = tostring(CombatLogStruct.HITTYPE).."-"..tostring(CombatLogStruct.SPELLNAME).."-"..SourceType.."-"..SourceName.."-"..TargetType.."-"..TargetName; -- parce que sur certains perso le meme sort peux faire du heal et du dgat
	
	SpellStruct = SpellTrackerDB.SPELLS[SpellIndexer] or {};
	
	SpellStruct.SpellIndexer = SpellIndexer;
	
	-- Amount / 0.40
	SpellStruct.AmountLine = SpellStruct.AmountLine or "0/0/0/0/0/0/0/0";
	
	--SpellStruct.SpellHitAmount = SpellStruct.SpellHitAmount or 0; -- init ot not
	--SpellStruct.SpellHitAndCritAmount = SpellStruct.SpellHitAndCritAmount or 0; -- init ot not
	--SpellStruct.SpellCritAmount = SpellStruct.SpellCritAmount or 0; -- init ot not
	--SpellStruct.SpellCritAndOverAmount = SpellStruct.SpellCritAndOverAmount or 0; -- init ot not
	--SpellStruct.SpellOverAmount = SpellStruct.SpellOverAmount or 0; -- init ot not
	--SpellStruct.SpellOverAndAbsorbAmount = SpellStruct.SpellOverAndAbsorbAmount or 0; -- init ot not
	--SpellStruct.SpellCritAndAbsorbAmount = SpellStruct.SpellCritAndAbsorbAmount or 0; -- init ot not
	--SpellStruct.SpellAbsorbAmount = SpellStruct.SpellAbsorbAmount or 0; -- init ot not
	
	SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal or 0; -- init ot not
	
	-- Amount BEst Spell ( Desactived for the moment )
	--SpellStruct.BestSpellAbsorbAmount = SpellStruct.BestSpellAbsorbAmount or 0; -- init ot not
	--SpellStruct.BestSpellCritAmount = SpellStruct.BestSpellCritAmount or 0; -- init ot not
	--SpellStruct.BestSpellHitAmount = SpellStruct.BestSpellHitAmount or 0; -- init ot not
	--SpellStruct.BestSpellOver = SpellStruct.BestSpellOver or 0; -- init ot not

	-- Ticks / 0.40
	SpellStruct.TicksLine = SpellStruct.TicksLine or "0/0/0/0/0/0/0/0/0";
	
	SpellStruct.CountTicks = SpellStruct.CountTicks or 0;
	--SpellStruct.CountSpellHit = SpellStruct.CountSpellHit or 0; -- Nombre de Hit
	--SpellStruct.CountSpellMissed = SpellStruct.CountSpellMissed or 0; -- Nombre de Hit
	--SpellStruct.CountSpellImmune = SpellStruct.CountSpellImmune or 0; -- Nombre de Hit
	--SpellStruct.CountSpellAbsorb = SpellStruct.CountSpellAbsorb or 0; -- Nombre de Hit
	--SpellStruct.CountSpellOver = SpellStruct.CountSpellOver or 0; -- Nombre de Hit
	--SpellStruct.CountSpellCrit = SpellStruct.CountSpellCrit or 0; -- Nombre de Hit
	--SpellStruct.CountSpellCritAndOver = SpellStruct.CountSpellCritAndOver or 0; -- Nombre de Hit
	--SpellStruct.CountSpellCritAndAbsorb = SpellStruct.CountSpellCritAndAbsorb or 0; -- Nombre de Hit
	--SpellStruct.CountSpellOverAndAbsorb = SpellStruct.CountSpellOverAndAbsorb or 0; -- Nombre de Hit
	
	-- Affect
	SpellStruct.SpellIconTex = ""; -- chemin de la texture du sort
	if ( SpellStruct.SpellId ) then
		if ( SpellStruct.SpellId ~= CombatLogStruct.SPELLID ) then
			SpellStruct.TickSpellId = CombatLogStruct.SPELLID;
		end
	else
		SpellStruct.SpellId = CombatLogStruct.SPELLID; -- id du sort
	end
	
	SpellStruct.SpellName = CombatLogStruct.SPELLNAME; -- nom du sort	
	SpellStruct.SpellHitType = CombatLogStruct.HITTYPE; -- type du sort
	SpellStruct.TargetType = TargetType;
	SpellStruct.TargetName = tostring(TargetName);
	SpellStruct.SourceType = SourceType;
	SpellStruct.SourceName = tostring(SourceName);
	SpellStruct.ReactionSrc = flagReactionSrc;
	SpellStruct.ReactionDst = flagReactionDst;
	--SpellStruct.SpellIconTex = GetSpellTexture(CombatLogStruct.SPELLNAME); -- GetSpellTexture ne renvoi que les textures des sorts de mon perso
	SpellStruct.SpellIconTex = SpellTracker:GetAllSpellTexture(SpellStruct.SpellId);
	
	SpellStruct.Used = false; -- indique si la barre affiche des donnes actuellment ( remet  false pendant le reset de la barre )
	
	--print("CombatLogStruct.HITTYPE=",CombatLogStruct.HITTYPE);
	--print("CombatLogStruct.AMOUNT=",CombatLogStruct.AMOUNT);
	--print("CombatLogStruct.OVERKILL=",CombatLogStruct.OVERKILL);
	--print("CombatLogStruct.ABSORBED=",CombatLogStruct.ABSORBED);
	--print("CombatLogStruct.OVERHEALING=",CombatLogStruct.OVERHEALING);
	
	CombatLogStruct.ABSORBED = CombatLogStruct.ABSORBED or 0;
	CombatLogStruct.OVERKILL = CombatLogStruct.OVERKILL or 0;
	CombatLogStruct.OVERHEALING = CombatLogStruct.OVERHEALING or 0;
	CombatLogStruct.CRITICAL = CombatLogStruct.CRITICAL or 0;
	if ( CombatLogStruct.OVERKILL < 0 ) then
		CombatLogStruct.OVERKILL = 0;
	end
	
	-- affectation des donnes selon le log de combat
	local SpellAmountTotal = 0;
	local SpellHitAmount = 0;
	local SpellCritAmount = 0;
	local SpellCritAndOverAmount = 0;
	local SpellOverAmount = 0;
	local SpellOverAndAbsorbAmount = 0;
	local SpellCritAndAbsorbAmount = 0;
	local SpellAbsorbAmount = 0;
	
	-- AMOUNT = 145000
	-- OVERKILL = 32000
	-- ce qui veut dure sur sur les 145000 seulement 32000 sont en exces
	-- donc AMOUNT vaut en fait AMOUNT - OVERKILL
	if ( CombatLogStruct.HITTYPE == "DAMAGE" ) then -- DAMAGE
		if ( CombatLogStruct.CRITICAL > 0 ) then -- crit
			SpellCritAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERKILL;
			SpellCritAndOverAmount = CombatLogStruct.OVERKILL;
			SpellCritAndAbsorbAmount = CombatLogStruct.ABSORBED;
		else -- normal
			SpellHitAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERKILL;
			SpellOverAmount = CombatLogStruct.OVERKILL;
			SpellAbsorbAmount = CombatLogStruct.ABSORBED;
		end
	elseif ( CombatLogStruct.HITTYPE == "HEAL" ) then -- HEAL
		if ( CombatLogStruct.CRITICAL > 0 ) then -- crit
			SpellCritAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERHEALING;
			SpellCritAndOverAmount = CombatLogStruct.OVERHEALING;
			SpellCritAndAbsorbAmount = CombatLogStruct.ABSORBED;
		else -- normal
			SpellHitAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERHEALING;
			SpellOverAmount = CombatLogStruct.OVERHEALING;
			SpellAbsorbAmount = CombatLogStruct.ABSORBED;
		end
	elseif ( CombatLogStruct.HITTYPE == "MISSED" ) then -- MISSED
		if ( CombatLogStruct.MISSEDTYPE == "ABSORB" ) then
			SpellAbsorbAmount = CombatLogStruct.AMOUNT or 0; -- au cas ou CombatLogStruct.AMOUNT vaudrait nil
		end
	end
	
	-- On recup les donnes actuelle / 0.40
	local LocalStruct = {};
	LocalStruct.SpellHitAmount, LocalStruct.SpellHitAndCritAmount, 
		LocalStruct.SpellCritAmount, LocalStruct.SpellCritAndOverAmount, LocalStruct.SpellOverAmount, 
		LocalStruct.SpellOverAndAbsorbAmount, LocalStruct.SpellCritAndAbsorbAmount, LocalStruct.SpellAbsorbAmount
		= string.match(SpellStruct.AmountLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
	LocalStruct.SpellHitAmount = tonumber(LocalStruct.SpellHitAmount);
	LocalStruct.SpellHitAndCritAmount = tonumber(LocalStruct.SpellHitAndCritAmount);
	LocalStruct.SpellCritAmount = tonumber(LocalStruct.SpellCritAmount);
	LocalStruct.SpellCritAndOverAmount = tonumber(LocalStruct.SpellCritAndOverAmount);
	LocalStruct.SpellOverAmount = tonumber(LocalStruct.SpellOverAmount);
	LocalStruct.SpellOverAndAbsorbAmount = tonumber(LocalStruct.SpellOverAndAbsorbAmount);
	LocalStruct.SpellCritAndAbsorbAmount = tonumber(LocalStruct.SpellCritAndAbsorbAmount);
	LocalStruct.SpellAbsorbAmount = tonumber(LocalStruct.SpellAbsorbAmount);
					
	LocalStruct.CountSpellHit, LocalStruct.CountSpellMissed, LocalStruct.CountSpellImmune, 
		LocalStruct.CountSpellAbsorb, LocalStruct.CountSpellOver, LocalStruct.CountSpellCrit, LocalStruct.CountSpellCritAndOver, 
		LocalStruct.CountSpellCritAndAbsorb, LocalStruct.CountSpellOverAndAbsorb
		= string.match(SpellStruct.TicksLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
	LocalStruct.CountSpellHit = tonumber(LocalStruct.CountSpellHit);
	LocalStruct.CountSpellMissed = tonumber(LocalStruct.CountSpellMissed);
	LocalStruct.CountSpellImmune = tonumber(LocalStruct.CountSpellImmune);
	LocalStruct.CountSpellAbsorb = tonumber(LocalStruct.CountSpellAbsorb);
	LocalStruct.CountSpellOver = tonumber(LocalStruct.CountSpellOver);
	LocalStruct.CountSpellCrit = tonumber(LocalStruct.CountSpellCrit);
	LocalStruct.CountSpellCritAndOver = tonumber(LocalStruct.CountSpellCritAndOver);
	LocalStruct.CountSpellCritAndAbsorb = tonumber(LocalStruct.CountSpellCritAndAbsorb);
	LocalStruct.CountSpellOverAndAbsorb = tonumber(LocalStruct.CountSpellOverAndAbsorb);
	
	-- Montants
	LocalStruct.SpellHitAmount = (LocalStruct.SpellHitAmount) + SpellHitAmount;
	LocalStruct.SpellCritAmount = (LocalStruct.SpellCritAmount) + SpellCritAmount;
	LocalStruct.SpellCritAndOverAmount = (LocalStruct.SpellCritAndOverAmount) + SpellCritAndOverAmount;
	LocalStruct.SpellOverAmount = (LocalStruct.SpellOverAmount) + SpellOverAmount;
	LocalStruct.SpellCritAndAbsorbAmount = (LocalStruct.SpellCritAndAbsorbAmount) + SpellCritAndAbsorbAmount;
	LocalStruct.SpellOverAndAbsorbAmount = (LocalStruct.SpellOverAndAbsorbAmount) + SpellOverAndAbsorbAmount;
	LocalStruct.SpellAbsorbAmount = (LocalStruct.SpellAbsorbAmount) + SpellAbsorbAmount;
	
	local CurrentSpellTotalAmount = 
		SpellCritAmount + SpellCritAndOverAmount + SpellCritAndAbsorbAmount + -- crit
		SpellHitAmount + SpellOverAmount + SpellAbsorbAmount; -- hit
		
	if ( CurrentSpellTotalAmount > 0 ) then -- on ajoute  la BD
		SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal + CurrentSpellTotalAmount;
	
		-- Ticks
		if ( SpellHitAmount > 0 ) then LocalStruct.CountSpellHit = LocalStruct.CountSpellHit + 1; end
		if ( SpellCritAmount > 0 ) then LocalStruct.CountSpellCrit = LocalStruct.CountSpellCrit + 1; end
		if ( SpellCritAndOverAmount > 0 ) then LocalStruct.CountSpellCritAndOver = LocalStruct.CountSpellCritAndOver + 1; end
		if ( SpellOverAmount > 0 ) then LocalStruct.CountSpellOver = LocalStruct.CountSpellOver + 1; end
		if ( SpellCritAndAbsorbAmount > 0 ) then LocalStruct.CountSpellCritAndAbsorb = LocalStruct.CountSpellCritAndAbsorb + 1; end
		if ( SpellOverAndAbsorbAmount > 0 ) then LocalStruct.CountSpellOverAndAbsorb = LocalStruct.CountSpellOverAndAbsorb + 1; end
		if ( SpellAbsorbAmount > 0 ) then LocalStruct.CountSpellAbsorb = LocalStruct.CountSpellAbsorb + 1; end
		
		-- 1 tick de plus
		SpellStruct.CountTicks = SpellStruct.CountTicks + 1;
		
		-- On retransforme les donnes en deux lignes / 0.40
		SpellStruct.AmountLine = LocalStruct.SpellHitAmount.."/"..LocalStruct.SpellHitAndCritAmount.."/"..
			LocalStruct.SpellCritAmount.."/"..LocalStruct.SpellCritAndOverAmount.."/"..
			LocalStruct.SpellOverAmount.."/"..LocalStruct.SpellOverAndAbsorbAmount.."/"..LocalStruct.SpellCritAndAbsorbAmount.."/"..
			LocalStruct.SpellAbsorbAmount;
			
		SpellStruct.TicksLine = LocalStruct.CountSpellHit.."/"..LocalStruct.CountSpellMissed.."/"..
			LocalStruct.CountSpellImmune.."/"..LocalStruct.CountSpellAbsorb.."/"..LocalStruct.CountSpellOver.."/"..
			LocalStruct.CountSpellCrit.."/"..LocalStruct.CountSpellCritAndOver.."/"..LocalStruct.CountSpellCritAndAbsorb.."/"..
			LocalStruct.CountSpellOverAndAbsorb;
			
		-- on stock ou on maj la structure
		SpellTrackerDB.SPELLS[SpellIndexer] = SpellStruct;
		
		-- On maj la frame / 0.40 ralentissait toute l'interface lors des raids capitale
		if ( SpellTrackerFrame ) then
			if ( SpellTrackerFrame:IsVisible() ) then
				SpellTracker:UpdateFrame();
			end
		end
	end
end

-- COMBAT_LOG_EVENT_UNFILTERED => Extracted form www.WowWiki.com/API_COMBAT_LOG_EVENT
--[[
1st Param 	2nd Param 	3rd Param 	4th Param 	5th Param 	6th Param 	7th Param 		8th Param 	9th Param 	10th Param 	11th Param
timestamp 	event 		hideCaster 	sourceGUID 	sourceName 	sourceFlags sourceFlags2 	destGUID 	destName 	destFlags 	destFlags2

prefix 			1st Parameter (12th) 	2nd Paramater (13th) 	3rd Parameter (14th)
SWING
RANGE 			spellId 				spellName 				spellSchool
SPELL 			spellId 				spellName 				spellSchool
SPELL_PERIODIC 	spellId 				spellName 				spellSchool
SPELL_BUILDING 	spellId 				spellName 				spellSchool
ENVIRONMENTAL 	environmentalType

Suffix 				1st Param (15th)	2nd Param (16th)	3rd Param (17th)	4th Param (18th)	5th Param (19th)	6th Param (20th)	7th Param (21th)	8th Param (22th)	9th Param (23th)
_DAMAGE 			amount 				overkill 			school 				resisted 			blocked 			absorbed 			critical (1 or nil) glancing (1 or nil) crushing (1 or nil)
_MISSED 			missType			isOffHand 			amountMissed*
_HEAL 				amount 				overhealing 		absorbed 			critical
_ENERGIZE 			amount 				powerType
_DRAIN 				amount 				powerType 			extraAmount
_LEECH 				amount 				powerType 			extraAmount
_INTERRUPT 			extraSpellID 		extraSpellName 		extraSchool
_DISPEL 			extraSpellID 		extraSpellName 		extraSchool 		auraType
_DISPEL_FAILED 		extraSpellID 		extraSpellName 		extraSchool
_STOLEN 			extraSpellID 		extraSpellName 		extraSchool 		auraType
_EXTRA_ATTACKS 		amount
_AURA_APPLIED 		auraType
_AURA_REMOVED 		auraType
_AURA_APPLIED_DOSE 	auraType 			amount
_AURA_REMOVED_DOSE 	auraType 			amount
_AURA_REFRESH 		auraType
_AURA_BROKEN 		auraType
_AURA_BROKEN_SPELL 	extraSpellID 		extraSpellName 		extraSchool 		auraType
_CAST_START
_CAST_SUCCESS
_CAST_FAILED 		failedType
_INSTAKILL
_DURABILITY_DAMAGE
_DURABILITY_DAMAGE_ALL
_CREATE
_SUMMON
_RESURRECT

Event 					Prefix to use 		Suffix to use
DAMAGE_SHIELD 			SPELL 				_DAMAGE
DAMAGE_SPLIT 			SPELL 				_DAMAGE
DAMAGE_SHIELD_MISSED 	SPELL 				_MISSED

Event 				1st Param 	2nd Param 	3rd Param
ENCHANT_APPLIED 	spellName 	itemID 		itemName
ENCHANT_REMOVED 	spellName 	itemID 		itemName
PARTY_KILL
UNIT_DIED
UNIT_DESTROYED

Event Prefix Description
SPELL_
Spell is the prefix for most effects even if the spell is a DoT or channeled. IE when the spell begins to be cast, SPELL_CAST_START is
fired and not SPELL_PERIODIC_CAST_START. This is the same with _MISS, _FAILED, etc.

SPELL_PERIODIC
Spell_PERIODIC Only the effects that are periodic start with this PREFIX. IE: Successfully casting a DoT only happens once therefor
even though the spell is periodic use the SPELL_ prefix. However, the damage is periodic so it will start with SPELL_PERIODIC_. 90%
of the time you will only care about _DAMAGE or _HEAL.
SPELL_BUILDING SPELL_BUILDING New in WotLK, assumed to be damage that can affect destructable buildings.
ENVIRONMENTAL sourceGUID = "0x0000000000000000", sourceName = nil

Suffixes
Event Prefix Description
_DAMAGE Triggered on damage to health. Nothing Special. (overkill returns a number greater than or equal to zero)

_MISSED
Triggered When Effect isn't applied but mana/energy is used IE: ABSORB BLOCK DEFLECT DODGE EVADE IMMUNE MISS
PARRY REFLECT RESIST

_HEAL Triggered when a unit is healed

_ENERGIZE
Any effect that restores energy/mana. Spell/trinket/item set bonuses can trigger this event. IE: Vampiric Touch, or Mark of
Defiance (Trinket)

_DRAIN Same as _ENERGIZE but this time you are losing energy/mana. Caused by enemies.

_LEECH Same as _DRAIN, but the source unit will simultaneously receive the same kind of energy (specified in extraAmount)

_INTERRUPT Spellcasting being interrupted by an ability such as Kick or Pummel.

_DISPEL A buff or debuff being actively dispelled by a spell like Remove Curse or Dispel Magic.

_DISPEL_FAILED A failed attempt to dispel a buff or debuff, most likely due to immunity.

_AURA_STOLEN A buff being transferred from the destination unit to the source unit (i.e. mages' Spellsteal).

_EXTRA_ATTACKS
Unit gains extra melee attacks due to an ability (like Sword Specialization or Windfury). These attacks usually happen in
brief succession 100-200ms following this event.

_AURA_APPLIED
Triggered When Buffs/Debuffs are Applied. Note: This event doesn't fire if a debuff is applied twice without being removed.
IE: casting Vampiric Embrace twice in a row only triggers this event once. This can make it difficult to track whether a debuff
was successfully reapplied to the target. However, for instant cast spells, SPELL_CAST_SUCCESS can be used.

_AURA_REMOVED Triggered When Buffs/Debuffs expire.

_AURA_APPLIED_DOSE
Triggered by stacking Debuffs if the debuff is already applied to a target. IE: If you cast Mind Flay twice it causes 2 doses of
shadow vunerability, the first time it will trigger, SPELL_AURA_APPLIED (arg10 = shadow vulnerability), and
SPELL_AURA_APPLIED_DOSE (arg10 = shadow vunerability) the second. The last argument reflects the new number of
doses on the unit.

_AURA_REMOVED_DOSE The opposite of _AURA_APPLIED_DOSE, reducing the amount of doses on a buff/debuff on the unit.

_AURA_REFRESH Resets the expiration timer of a buff/debuff on the unit.

_AURA_BROKEN A buff or debuff is being removed by melee damage

_AURA_BROKEN_SPELL A buff or debuff is being removed by spell damage (specified in extraSpell...)

_CAST_START
Triggered when a spell begins casting. Instant Cast and channeled spells don't invoke this event. They trigger

_CAST_SUCCESS, _MISS instead.

_CAST_SUCCESS
Triggered when channeled spells begin or when instant cast spells are cast. This (obviously) isn't triggered when this spell
misses. On a miss SPELL_MISS will be triggered instead. Also, spells that invoke _CAST_START don't trigger this event
when they are done casting. Use _SPELL_MISS or _SPELL_DAMAGE or _SPELL_AURA_APPLIED to see when they were
cast

_CAST_FAILED
If the cast fails before it starts (IE invalid target), then _CAST_START never triggers. However it is possible for a cast to fail
after beginning. (IE you jump, move, hit escape etc.)

_INSTAKILL Immediately kills the destination unit (usually happens when warlocks sacrifice their minions).

_DURABILITY_DAMAGE

_DURABILITY_DAMAGE_ALL

_CREATE Creates an object (as opposed to an NPC who are 'summoned') like a hunter's trap or a mage's portal.

_SUMMON Summmons an NPC such as a pet or totem.

Special Events
Event Description
UNIT_DIED destGUID and destName refer to the unit that died.
PARTY_KILL includes both sourceGUID and destGUID, but only reports for you (not in a party) or your other 4 party members (not raid members)
]]--